package ru.ifmo.fileShare;

import ru.ifmo.fileShare.transport.FileListItem;

public interface ClientEventListener {
    /**
     * Server disconnection handler
     */
    void onServerDisconnect();

    /**
     * Client quited handler
     */
    void onClientQuited();

    /**
     * Server dropped handler
     */
    void onServerDropped();

    /**
     * Connection error handler
     * @param reason error reason
     */
    void onConnectionError(String reason);

    /**
     * connection handler
     */
    void onConnectedToServer();

    /**
     * connection handler
     */
    void onSessionClosed();

    /**
     * List recieved handler
     * @param fileListItems recieved list
     */
    void onListRecieved(FileListItem[] fileListItems);

    /**
     * File recieved handler
     */
    void onFileRecieved();

    /**
     * File part recieved handler
     * @param downloadedSize file size downloaded so far
     */
    void onFilePartRecieved(long downloadedSize);
}
