/**
 * This file was generated from model [ClientModel] on [Fri Feb 16 00:45:53 MSK 2007].
 * Do not change content of this file.
 */
package ru.ifmo.fileShare;

import com.evelopers.common.exception.CommonException;
import com.evelopers.common.exception.SystemException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import com.evelopers.unimod.runtime.logger.SimpleLogger;
import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.IOException;
import java.util.*;


public class ClientModelEventProcessor extends AbstractEventProcessor {

    private ModelStructure modelStructure;

    private static final int A1 = 1;

    private int decodeStateMachine(String sm) {

        if ("A1".equals(sm)) {
            return A1;
        }

        return -1;
    }

    private A1EventProcessor _A1;

    public ClientModelEventProcessor() {
        modelStructure = new ClientModelModelStructure();

        _A1 = new A1EventProcessor();
    }

    public static void run(int debuggerPort, boolean debuggerSuspend) throws
            InterruptedException, EventProcessorException, CommonException,
            IOException {

        /* Create runtime engine */
        ModelEngine engine = createModelEngine(true);

        /* Setup logger */
        final Log log = LogFactory.getLog(ClientModelEventProcessor.class);
        engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        /* Setup exception handler */
        engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
            public void handleException(StateMachineContext context, SystemException e) {
                log.fatal(e.getChainedMessage(), e.getRootException());
            }
        });

        if (debuggerPort > 0) {
            AppDebugger d = new AppDebugger(
                    debuggerPort, debuggerSuspend,
                    new JavaSpecificMessageCoder(), engine);
            d.start();
        }
        engine.start();
    }

    public static void main(String[] args) throws Exception {
        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        ClientModelEventProcessor.run(debuggerPort, debuggerSuspend);
    }

    public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        ObjectsManager objectsManager = new ObjectsManager();
        return ModelEngine.createStandAlone(
                useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(),
                new ClientModelEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
    }

    public static class ObjectsManager {
        private ru.ifmo.fileShare.client.ClientController o1 = null;
        private ru.ifmo.fileShare.client.ClientUserEventProvider p1 = null;
        private ru.ifmo.fileShare.client.ClientTimer p2 = null;
        private ru.ifmo.fileShare.client.ClientSocket p3 = null;

        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

        public ControlledObjectsManager getControlledObjectsManager() {
            return controlledObjectsManager;
        }

        public EventProvidersManager getEventProvidersManager() {
            return eventProvidersManager;
        }

        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
            public void init(ModelEngine engine) throws CommonException {
            }

            public void dispose() {
            }

            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "o1")) {
                    if (o1 == null) {
                        o1 = new ru.ifmo.fileShare.client.ClientController();
                    }
                    return o1;
                }
                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
            }
        }

        private class EventProvidersManagerImpl implements EventProvidersManager {
            private List nonameEventProviders = new ArrayList();

            public void init(ModelEngine engine) throws CommonException {
                EventProvider ep;
                ep = getEventProvider("p1");
                ep.init(engine);
                ep = getEventProvider("p2");
                ep.init(engine);
                ep = getEventProvider("p3");
                ep.init(engine);
            }

            public void dispose() {
                EventProvider ep;
                ep = getEventProvider("p1");
                ep.dispose();
                ep = getEventProvider("p2");
                ep.dispose();
                ep = getEventProvider("p3");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

            public EventProvider getEventProvider(String epName) {
                if (StringUtils.equals(epName, "p1")) {
                    if (p1 == null) {
                        p1 = new ru.ifmo.fileShare.client.ClientUserEventProvider();
                    }
                    return p1;
                }
                if (StringUtils.equals(epName, "p2")) {
                    if (p2 == null) {
                        p2 = new ru.ifmo.fileShare.client.ClientTimer();
                    }
                    return p2;
                }
                if (StringUtils.equals(epName, "p3")) {
                    if (p3 == null) {
                        p3 = new ru.ifmo.fileShare.client.ClientSocket();
                    }
                    return p3;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
            }
        }
    }

    public ModelStructure getModelStructure() {
        return modelStructure;
    }

    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);

        _A1.init(controlledObjectsMap);
    }

    protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());

        try {
            switch (sm) {
                case A1:
                    return _A1.process(event, context, path, config);
                default:
                    throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
            }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw(SystemException) e;
            } else {
                throw new SystemException(e);
            }
        }
    }

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());

        try {
            switch (sm) {
                case A1:
                    return _A1.transiteToStableState(context, path, config);
                default:
                    throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
            }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw(SystemException) e;
            } else {
                throw new SystemException(e);
            }
        }
    }


    private class ClientModelModelStructure implements ModelStructure {
        private Map configManagers = new HashMap();

        private ClientModelModelStructure() {
            configManagers.put("A1", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
        }

        public StateMachinePath getRootPath()
                throws EventProcessorException {
            return new StateMachinePath("A1");
        }

        public StateMachineConfigManager getConfigManager(String stateMachine)
                throws EventProcessorException {
            return (StateMachineConfigManager) configManagers.get(stateMachine);
        }

        public StateMachineConfig getTopConfig(String stateMachine)
                throws EventProcessorException {
            int sm = decodeStateMachine(stateMachine);

            switch (sm) {
                case A1:
                    return new StateMachineConfig("Top");
                default:
                    throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
            }
        }

        public boolean isFinal(String stateMachine, StateMachineConfig config)
                throws EventProcessorException {
            /* Get state machine from path */
            int sm = decodeStateMachine(stateMachine);
            int state;
            switch (sm) {
                case A1:
                    state = _A1.decodeState(config.getActiveState());
                    switch (state) {
                        case A1EventProcessor.s2:
                            return true;
                        default:
                            return false;
                    }
                default:
                    throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
            }
        }
    }


    private class A1EventProcessor {

        // states
        private static final int Top = 1;
        private static final int Connected = 2;
        private static final int Getting_List = 3;
        private static final int Getting_File = 4;
        private static final int Handshaking = 5;
        private static final int Idle = 6;
        private static final int s2 = 7;
        private static final int s1 = 8;
        private static final int Disconnected = 9;

        private int decodeState(String state) {

            if ("Top".equals(state)) {
                return Top;
            } else if ("Connected".equals(state)) {
                return Connected;
            } else if ("Getting List".equals(state)) {
                return Getting_List;
            } else if ("Getting File".equals(state)) {
                return Getting_File;
            } else if ("Handshaking".equals(state)) {
                return Handshaking;
            } else if ("Idle".equals(state)) {
                return Idle;
            } else if ("s2".equals(state)) {
                return s2;
            } else if ("s1".equals(state)) {
                return s1;
            } else if ("Disconnected".equals(state)) {
                return Disconnected;
            }

            return -1;
        }

        // events
        private static final int e114 = 1;
        private static final int e136 = 2;
        private static final int e115 = 3;
        private static final int e133 = 4;
        private static final int e116 = 5;
        private static final int e111 = 6;
        private static final int e112 = 7;
        private static final int e134 = 8;
        private static final int e131 = 9;
        private static final int e132 = 10;
        private static final int e113 = 11;
        private static final int e121 = 12;
        private static final int e135 = 13;

        private int decodeEvent(String event) {

            if ("e114".equals(event)) {
                return e114;
            } else if ("e136".equals(event)) {
                return e136;
            } else if ("e115".equals(event)) {
                return e115;
            } else if ("e133".equals(event)) {
                return e133;
            } else if ("e116".equals(event)) {
                return e116;
            } else if ("e111".equals(event)) {
                return e111;
            } else if ("e112".equals(event)) {
                return e112;
            } else if ("e134".equals(event)) {
                return e134;
            } else if ("e131".equals(event)) {
                return e131;
            } else if ("e132".equals(event)) {
                return e132;
            } else if ("e113".equals(event)) {
                return e113;
            } else if ("e121".equals(event)) {
                return e121;
            } else if ("e135".equals(event)) {
                return e135;
            }

            return -1;
        }

        private ru.ifmo.fileShare.client.ClientController o1;

        private void init(ControlledObjectsMap controlledObjectsMap) {
            o1 = (ru.ifmo.fileShare.client.ClientController) controlledObjectsMap.getControlledObject("o1");
        }

        private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
            config = lookForTransition(event, context, path, config);

            config = transiteToStableState(context, path, config);

            // execute included state machines
            executeSubmachines(event, context, path, config);

            return config;
        }

        private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
            int state = decodeState(config.getActiveState());

            while (true) {
                switch (state) {
                    case Connected:

                        return;
                    case Getting_List:

                        state = Connected;
                        break;
                    case Getting_File:

                        state = Connected;
                        break;
                    case Handshaking:

                        state = Connected;
                        break;
                    case Idle:

                        state = Connected;
                        break;
                    case s2:

                        return;
                    case s1:

                        return;
                    case Disconnected:

                        return;
                    default:
                        throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A1]");
                }
            }
        }

        private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

            int s = decodeState(config.getActiveState());
            Event event;

            switch (s) {
                case Top:


                    fireComeToState(context, path, "s1");

                    // s1->Disconnected [true]/
                    event = Event.NO_EVENT;
                    fireTransitionFound(context, path, "s1", event, "s1#Disconnected##true");


                    fireComeToState(context, path, "Disconnected");

                    // Disconnected []

                    return new StateMachineConfig("Disconnected");
            }

            return config;
        }

        private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {


            boolean

                    o1_x1 = false;


            BitSet calculatedInputActions = new BitSet(1);

            int s = decodeState(config.getActiveState());
            int e = decodeEvent(event.getName());

            while (true) {
                switch (s) {
                    case Connected:

                        fireTransitionsOfSuperstate(context, path, "Connected", event);

                        switch (e) {
                            case e136:

                                // Connected->Disconnected e136[true]/o1.z16,o1.z17

                                fireTransitionCandidate(context, path, "Connected", event, "Connected#Disconnected#e136#true");


                                fireTransitionFound(context, path, "Connected", event, "Connected#Disconnected#e136#true");

                                fireBeforeOutputActionExecution(context, path, "Connected#Disconnected#e136#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Connected#Disconnected#e136#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Connected#Disconnected#e136#true", "o1.z17");

                                o1.z17(context);

                                fireAfterOutputActionExecution(context, path, "Connected#Disconnected#e136#true", "o1.z17");

                                fireComeToState(context, path, "Disconnected");

                                // Disconnected []
                                return new StateMachineConfig("Disconnected");


                            case e115:

                                // Connected->Disconnected e115[true]/o1.z16,o1.z13

                                fireTransitionCandidate(context, path, "Connected", event, "Connected#Disconnected#e115#true");


                                fireTransitionFound(context, path, "Connected", event, "Connected#Disconnected#e115#true");

                                fireBeforeOutputActionExecution(context, path, "Connected#Disconnected#e115#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Connected#Disconnected#e115#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Connected#Disconnected#e115#true", "o1.z13");

                                o1.z13(context);

                                fireAfterOutputActionExecution(context, path, "Connected#Disconnected#e115#true", "o1.z13");

                                fireComeToState(context, path, "Disconnected");

                                // Disconnected []
                                return new StateMachineConfig("Disconnected");


                            case e116:

                                // Connected->s2 e116[true]/o1.z13,o1.z16,o1.z18

                                fireTransitionCandidate(context, path, "Connected", event, "Connected#s2#e116#true");


                                fireTransitionFound(context, path, "Connected", event, "Connected#s2#e116#true");

                                fireBeforeOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z13");

                                o1.z13(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z13");
                                fireBeforeOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z18");

                                o1.z18(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s2#e116#true", "o1.z18");

                                fireComeToState(context, path, "s2");

                                // s2 []
                                return new StateMachineConfig("s2");


                            default:

                                // transition not found
                                return config;
                        }

                    case Getting_List:


                        switch (e) {
                            case e136:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e132:

                                // Getting List->Getting List e132[true]/o1.z16,o1.z6,o1.z5,o1.z14

                                fireTransitionCandidate(context, path, "Getting List", event, "Getting List#Getting List#e132#true");


                                fireTransitionFound(context, path, "Getting List", event, "Getting List#Getting List#e132#true");

                                fireBeforeOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z6");

                                o1.z6(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z6");
                                fireBeforeOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z5");

                                o1.z5(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z5");
                                fireBeforeOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z14");

                                o1.z14(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Getting List#e132#true", "o1.z14");

                                fireComeToState(context, path, "Getting List");

                                // Getting List []
                                return new StateMachineConfig("Getting List");


                            case e115:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e121:

                                // Getting List->Disconnected e121[true]/o1.z13,o1.z15

                                fireTransitionCandidate(context, path, "Getting List", event, "Getting List#Disconnected#e121#true");


                                fireTransitionFound(context, path, "Getting List", event, "Getting List#Disconnected#e121#true");

                                fireBeforeOutputActionExecution(context, path, "Getting List#Disconnected#e121#true", "o1.z13");

                                o1.z13(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Disconnected#e121#true", "o1.z13");
                                fireBeforeOutputActionExecution(context, path, "Getting List#Disconnected#e121#true", "o1.z15");

                                o1.z15(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Disconnected#e121#true", "o1.z15");

                                fireComeToState(context, path, "Disconnected");

                                // Disconnected []
                                return new StateMachineConfig("Disconnected");


                            case e133:

                                // Getting List->Idle e133[true]/o1.z16,o1.z7

                                fireTransitionCandidate(context, path, "Getting List", event, "Getting List#Idle#e133#true");


                                fireTransitionFound(context, path, "Getting List", event, "Getting List#Idle#e133#true");

                                fireBeforeOutputActionExecution(context, path, "Getting List#Idle#e133#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Idle#e133#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Getting List#Idle#e133#true", "o1.z7");

                                o1.z7(context);

                                fireAfterOutputActionExecution(context, path, "Getting List#Idle#e133#true", "o1.z7");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            case e116:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Getting_File:


                        switch (e) {
                            case e134:

                                // Getting File->Getting File e134[true]/o1.z16,o1.z11,o1.z9,o1.z14

                                fireTransitionCandidate(context, path, "Getting File", event, "Getting File#Getting File#e134#true");


                                fireTransitionFound(context, path, "Getting File", event, "Getting File#Getting File#e134#true");

                                fireBeforeOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z11");

                                o1.z11(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z11");
                                fireBeforeOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z9");

                                o1.z9(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z9");
                                fireBeforeOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z14");

                                o1.z14(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Getting File#e134#true", "o1.z14");

                                fireComeToState(context, path, "Getting File");

                                // Getting File []
                                return new StateMachineConfig("Getting File");


                            case e114:

                                // Getting File->Idle e114[true]/o1.z16

                                fireTransitionCandidate(context, path, "Getting File", event, "Getting File#Idle#e114#true");


                                fireTransitionFound(context, path, "Getting File", event, "Getting File#Idle#e114#true");

                                fireBeforeOutputActionExecution(context, path, "Getting File#Idle#e114#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Idle#e114#true", "o1.z16");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            case e136:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e115:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e121:

                                // Getting File->Disconnected e121[true]/o1.z13,o1.z15

                                fireTransitionCandidate(context, path, "Getting File", event, "Getting File#Disconnected#e121#true");


                                fireTransitionFound(context, path, "Getting File", event, "Getting File#Disconnected#e121#true");

                                fireBeforeOutputActionExecution(context, path, "Getting File#Disconnected#e121#true", "o1.z13");

                                o1.z13(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Disconnected#e121#true", "o1.z13");
                                fireBeforeOutputActionExecution(context, path, "Getting File#Disconnected#e121#true", "o1.z15");

                                o1.z15(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Disconnected#e121#true", "o1.z15");

                                fireComeToState(context, path, "Disconnected");

                                // Disconnected []
                                return new StateMachineConfig("Disconnected");


                            case e135:

                                // Getting File->Idle e135[true]/o1.z16,o1.z12

                                fireTransitionCandidate(context, path, "Getting File", event, "Getting File#Idle#e135#true");


                                fireTransitionFound(context, path, "Getting File", event, "Getting File#Idle#e135#true");

                                fireBeforeOutputActionExecution(context, path, "Getting File#Idle#e135#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Idle#e135#true", "o1.z16");
                                fireBeforeOutputActionExecution(context, path, "Getting File#Idle#e135#true", "o1.z12");

                                o1.z12(context);

                                fireAfterOutputActionExecution(context, path, "Getting File#Idle#e135#true", "o1.z12");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            case e116:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Handshaking:


                        switch (e) {
                            case e131:

                                // Handshaking->Idle e131[true]/o1.z3,o1.z16

                                fireTransitionCandidate(context, path, "Handshaking", event, "Handshaking#Idle#e131#true");


                                fireTransitionFound(context, path, "Handshaking", event, "Handshaking#Idle#e131#true");

                                fireBeforeOutputActionExecution(context, path, "Handshaking#Idle#e131#true", "o1.z3");

                                o1.z3(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Idle#e131#true", "o1.z3");
                                fireBeforeOutputActionExecution(context, path, "Handshaking#Idle#e131#true", "o1.z16");

                                o1.z16(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Idle#e131#true", "o1.z16");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            case e136:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e115:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e121:

                                // Handshaking->Disconnected e121[true]/o1.z13,o1.z15

                                fireTransitionCandidate(context, path, "Handshaking", event, "Handshaking#Disconnected#e121#true");


                                fireTransitionFound(context, path, "Handshaking", event, "Handshaking#Disconnected#e121#true");

                                fireBeforeOutputActionExecution(context, path, "Handshaking#Disconnected#e121#true", "o1.z13");

                                o1.z13(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Disconnected#e121#true", "o1.z13");
                                fireBeforeOutputActionExecution(context, path, "Handshaking#Disconnected#e121#true", "o1.z15");

                                o1.z15(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Disconnected#e121#true", "o1.z15");

                                fireComeToState(context, path, "Disconnected");

                                // Disconnected []
                                return new StateMachineConfig("Disconnected");


                            case e116:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Idle:


                        switch (e) {
                            case e112:

                                // Idle->Getting List e112[true]/o1.z4,o1.z14

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Getting List#e112#true");


                                fireTransitionFound(context, path, "Idle", event, "Idle#Getting List#e112#true");

                                fireBeforeOutputActionExecution(context, path, "Idle#Getting List#e112#true", "o1.z4");

                                o1.z4(context);

                                fireAfterOutputActionExecution(context, path, "Idle#Getting List#e112#true", "o1.z4");
                                fireBeforeOutputActionExecution(context, path, "Idle#Getting List#e112#true", "o1.z14");

                                o1.z14(context);

                                fireAfterOutputActionExecution(context, path, "Idle#Getting List#e112#true", "o1.z14");

                                fireComeToState(context, path, "Getting List");

                                // Getting List []
                                return new StateMachineConfig("Getting List");


                            case e136:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e113:

                                // Idle->Getting File e113[true]/o1.z8,o1.z14

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Getting File#e113#true");


                                fireTransitionFound(context, path, "Idle", event, "Idle#Getting File#e113#true");

                                fireBeforeOutputActionExecution(context, path, "Idle#Getting File#e113#true", "o1.z8");

                                o1.z8(context);

                                fireAfterOutputActionExecution(context, path, "Idle#Getting File#e113#true", "o1.z8");
                                fireBeforeOutputActionExecution(context, path, "Idle#Getting File#e113#true", "o1.z14");

                                o1.z14(context);

                                fireAfterOutputActionExecution(context, path, "Idle#Getting File#e113#true", "o1.z14");

                                fireComeToState(context, path, "Getting File");

                                // Getting File []
                                return new StateMachineConfig("Getting File");


                            case e115:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e116:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Disconnected:


                        switch (e) {
                            case e116:

                                // Disconnected->s2 e116[true]/o1.z18

                                fireTransitionCandidate(context, path, "Disconnected", event, "Disconnected#s2#e116#true");


                                fireTransitionFound(context, path, "Disconnected", event, "Disconnected#s2#e116#true");

                                fireBeforeOutputActionExecution(context, path, "Disconnected#s2#e116#true", "o1.z18");

                                o1.z18(context);

                                fireAfterOutputActionExecution(context, path, "Disconnected#s2#e116#true", "o1.z18");

                                fireComeToState(context, path, "s2");

                                // s2 []
                                return new StateMachineConfig("s2");


                            case e111:

                                // Disconnected->Disconnected e111[!o1.x1]/o1.z2

                                fireTransitionCandidate(context, path, "Disconnected", event, "Disconnected#Disconnected#e111#!o1.x1");

                                if (!isInputActionCalculated(calculatedInputActions, _o1_x1)) {

                                    fireBeforeInputActionExecution(context, path, "Disconnected#Disconnected#e111#!o1.x1", "o1.x1");

                                    o1_x1 = o1.x1(context);

                                    fireAfterInputActionExecution(context, path, "Disconnected#Disconnected#e111#!o1.x1", "o1.x1", new Boolean(o1_x1));
                                }


                                if (!o1_x1) {

                                    fireTransitionFound(context, path, "Disconnected", event, "Disconnected#Disconnected#e111#!o1.x1");

                                    fireBeforeOutputActionExecution(context, path, "Disconnected#Disconnected#e111#!o1.x1", "o1.z2");

                                    o1.z2(context);

                                    fireAfterOutputActionExecution(context, path, "Disconnected#Disconnected#e111#!o1.x1", "o1.z2");

                                    fireComeToState(context, path, "Disconnected");

                                    // Disconnected []
                                    return new StateMachineConfig("Disconnected");

                                }
                                // Disconnected->Handshaking e111[o1.x1]/o1.z1,o1.z14

                                fireTransitionCandidate(context, path, "Disconnected", event, "Disconnected#Handshaking#e111#o1.x1");


                                if (o1_x1) {

                                    fireTransitionFound(context, path, "Disconnected", event, "Disconnected#Handshaking#e111#o1.x1");

                                    fireBeforeOutputActionExecution(context, path, "Disconnected#Handshaking#e111#o1.x1", "o1.z1");

                                    o1.z1(context);

                                    fireAfterOutputActionExecution(context, path, "Disconnected#Handshaking#e111#o1.x1", "o1.z1");
                                    fireBeforeOutputActionExecution(context, path, "Disconnected#Handshaking#e111#o1.x1", "o1.z14");

                                    o1.z14(context);

                                    fireAfterOutputActionExecution(context, path, "Disconnected#Handshaking#e111#o1.x1", "o1.z14");

                                    fireComeToState(context, path, "Handshaking");

                                    // Handshaking []
                                    return new StateMachineConfig("Handshaking");

                                }

                                // transition not found
                                return config;
                            default:

                                // transition not found
                                return config;
                        }

                    default:
                        throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A1]");
                }
            }
        }

        //o1.x1
        private static final int _o1_x1 = 0;

    }

    private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
        boolean b = calculatedInputActions.get(k);

        if (!b) {
            calculatedInputActions.set(k);
        }

        return b;
    }

}
	
