/**
 * This file was generated from model [ServerModel] on [Fri Feb 16 00:45:52 MSK 2007].
 * Do not change content of this file.
 */
package ru.ifmo.fileShare;

import com.evelopers.common.exception.CommonException;
import com.evelopers.common.exception.SystemException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import com.evelopers.unimod.runtime.logger.SimpleLogger;
import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.IOException;
import java.util.*;


public class ServerModelEventProcessor extends AbstractEventProcessor {

    private ModelStructure modelStructure;

    private static final int A2 = 1;

    private int decodeStateMachine(String sm) {

        if ("A2".equals(sm)) {
            return A2;
        }

        return -1;
    }

    private A2EventProcessor _A2;

    public ServerModelEventProcessor() {
        modelStructure = new ServerModelModelStructure();

        _A2 = new A2EventProcessor();
    }

    public static void run(int debuggerPort, boolean debuggerSuspend) throws
            InterruptedException, EventProcessorException, CommonException,
            IOException {

        /* Create runtime engine */
        ModelEngine engine = createModelEngine(true);

        /* Setup logger */
        final Log log = LogFactory.getLog(ServerModelEventProcessor.class);
        engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        /* Setup exception handler */
        engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
            public void handleException(StateMachineContext context, SystemException e) {
                log.fatal(e.getChainedMessage(), e.getRootException());
            }
        });

        if (debuggerPort > 0) {
            AppDebugger d = new AppDebugger(
                    debuggerPort, debuggerSuspend,
                    new JavaSpecificMessageCoder(), engine);
            d.start();
        }
        engine.start();
    }

    public static void main(String[] args) throws Exception {
        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        ServerModelEventProcessor.run(debuggerPort, debuggerSuspend);
    }

    public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        ObjectsManager objectsManager = new ObjectsManager();
        return ModelEngine.createStandAlone(
                useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(),
                new ServerModelEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
    }

    public static class ObjectsManager {
        private ru.ifmo.fileShare.server.ServerController o2 = null;
        private ru.ifmo.fileShare.server.ServerSocket p6 = null;
        private ru.ifmo.fileShare.server.ServerUserEventProvider p4 = null;
        private ru.ifmo.fileShare.server.ServerTimer p5 = null;

        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

        public ControlledObjectsManager getControlledObjectsManager() {
            return controlledObjectsManager;
        }

        public EventProvidersManager getEventProvidersManager() {
            return eventProvidersManager;
        }

        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
            public void init(ModelEngine engine) throws CommonException {
            }

            public void dispose() {
            }

            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "o2")) {
                    if (o2 == null) {
                        o2 = new ru.ifmo.fileShare.server.ServerController();
                    }
                    return o2;
                }
                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
            }
        }

        private class EventProvidersManagerImpl implements EventProvidersManager {
            private List nonameEventProviders = new ArrayList();

            public void init(ModelEngine engine) throws CommonException {
                EventProvider ep;
                ep = getEventProvider("p6");
                ep.init(engine);
                ep = getEventProvider("p4");
                ep.init(engine);
                ep = getEventProvider("p5");
                ep.init(engine);
            }

            public void dispose() {
                EventProvider ep;
                ep = getEventProvider("p6");
                ep.dispose();
                ep = getEventProvider("p4");
                ep.dispose();
                ep = getEventProvider("p5");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

            public EventProvider getEventProvider(String epName) {
                if (StringUtils.equals(epName, "p6")) {
                    if (p6 == null) {
                        p6 = new ru.ifmo.fileShare.server.ServerSocket();
                    }
                    return p6;
                }
                if (StringUtils.equals(epName, "p4")) {
                    if (p4 == null) {
                        p4 = new ru.ifmo.fileShare.server.ServerUserEventProvider();
                    }
                    return p4;
                }
                if (StringUtils.equals(epName, "p5")) {
                    if (p5 == null) {
                        p5 = new ru.ifmo.fileShare.server.ServerTimer();
                    }
                    return p5;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
            }
        }
    }

    public ModelStructure getModelStructure() {
        return modelStructure;
    }

    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);

        _A2.init(controlledObjectsMap);
    }

    protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());

        try {
            switch (sm) {
                case A2:
                    return _A2.process(event, context, path, config);
                default:
                    throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
            }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw(SystemException) e;
            } else {
                throw new SystemException(e);
            }
        }
    }

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

        // get state machine from path
        int sm = decodeStateMachine(path.getStateMachine());

        try {
            switch (sm) {
                case A2:
                    return _A2.transiteToStableState(context, path, config);
                default:
                    throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
            }
        } catch (Exception e) {
            if (e instanceof SystemException) {
                throw(SystemException) e;
            } else {
                throw new SystemException(e);
            }
        }
    }


    private class ServerModelModelStructure implements ModelStructure {
        private Map configManagers = new HashMap();

        private ServerModelModelStructure() {
            configManagers.put("A2", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
        }

        public StateMachinePath getRootPath()
                throws EventProcessorException {
            return new StateMachinePath("A2");
        }

        public StateMachineConfigManager getConfigManager(String stateMachine)
                throws EventProcessorException {
            return (StateMachineConfigManager) configManagers.get(stateMachine);
        }

        public StateMachineConfig getTopConfig(String stateMachine)
                throws EventProcessorException {
            int sm = decodeStateMachine(stateMachine);

            switch (sm) {
                case A2:
                    return new StateMachineConfig("Top");
                default:
                    throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
            }
        }

        public boolean isFinal(String stateMachine, StateMachineConfig config)
                throws EventProcessorException {
            /* Get state machine from path */
            int sm = decodeStateMachine(stateMachine);
            int state;
            switch (sm) {
                case A2:
                    state = _A2.decodeState(config.getActiveState());
                    switch (state) {
                        case A2EventProcessor.s8:
                            return true;
                        default:
                            return false;
                    }
                default:
                    throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
            }
        }
    }


    private class A2EventProcessor {

        // states
        private static final int Top = 1;
        private static final int s8 = 2;
        private static final int Connected = 3;
        private static final int Sending_File = 4;
        private static final int Sending_List = 5;
        private static final int Idle = 6;
        private static final int s1 = 7;
        private static final int Handshaking = 8;

        private int decodeState(String state) {

            if ("Top".equals(state)) {
                return Top;
            } else if ("s8".equals(state)) {
                return s8;
            } else if ("Connected".equals(state)) {
                return Connected;
            } else if ("Sending File".equals(state)) {
                return Sending_File;
            } else if ("Sending List".equals(state)) {
                return Sending_List;
            } else if ("Idle".equals(state)) {
                return Idle;
            } else if ("s1".equals(state)) {
                return s1;
            } else if ("Handshaking".equals(state)) {
                return Handshaking;
            }

            return -1;
        }

        // events
        private static final int e232 = 1;
        private static final int e235 = 2;
        private static final int e231 = 3;
        private static final int e234 = 4;
        private static final int e237 = 5;
        private static final int e233 = 6;
        private static final int e211 = 7;
        private static final int e236 = 8;
        private static final int e221 = 9;

        private int decodeEvent(String event) {

            if ("e232".equals(event)) {
                return e232;
            } else if ("e235".equals(event)) {
                return e235;
            } else if ("e231".equals(event)) {
                return e231;
            } else if ("e234".equals(event)) {
                return e234;
            } else if ("e237".equals(event)) {
                return e237;
            } else if ("e233".equals(event)) {
                return e233;
            } else if ("e211".equals(event)) {
                return e211;
            } else if ("e236".equals(event)) {
                return e236;
            } else if ("e221".equals(event)) {
                return e221;
            }

            return -1;
        }

        private ru.ifmo.fileShare.server.ServerController o2;

        private void init(ControlledObjectsMap controlledObjectsMap) {
            o2 = (ru.ifmo.fileShare.server.ServerController) controlledObjectsMap.getControlledObject("o2");
        }

        private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
            config = lookForTransition(event, context, path, config);

            config = transiteToStableState(context, path, config);

            // execute included state machines
            executeSubmachines(event, context, path, config);

            return config;
        }

        private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
            int state = decodeState(config.getActiveState());

            while (true) {
                switch (state) {
                    case s8:

                        return;
                    case Connected:

                        return;
                    case Sending_File:

                        state = Connected;
                        break;
                    case Sending_List:

                        state = Connected;
                        break;
                    case Idle:

                        state = Connected;
                        break;
                    case s1:

                        return;
                    case Handshaking:

                        return;
                    default:
                        throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A2]");
                }
            }
        }

        private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

            int s = decodeState(config.getActiveState());
            Event event;

            switch (s) {
                case Top:


                    fireComeToState(context, path, "s1");

                    // s1->Handshaking [true]/
                    event = Event.NO_EVENT;
                    fireTransitionFound(context, path, "s1", event, "s1#Handshaking##true");


                    fireComeToState(context, path, "Handshaking");

                    // Handshaking []

                    return new StateMachineConfig("Handshaking");
            }

            return config;
        }

        private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {


            boolean

                    o2_x1 = false,

                    o2_x2 = false;


            BitSet calculatedInputActions = new BitSet(2);

            int s = decodeState(config.getActiveState());
            int e = decodeEvent(event.getName());

            while (true) {
                switch (s) {
                    case Connected:

                        fireTransitionsOfSuperstate(context, path, "Connected", event);

                        switch (e) {
                            case e211:

                                // Connected->s8 e211[true]/o2.z7,o2.z10,o2.z12

                                fireTransitionCandidate(context, path, "Connected", event, "Connected#s8#e211#true");


                                fireTransitionFound(context, path, "Connected", event, "Connected#s8#e211#true");

                                fireBeforeOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z7");

                                o2.z7(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z7");
                                fireBeforeOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z10");

                                o2.z10(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z10");
                                fireBeforeOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z12");

                                o2.z12(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s8#e211#true", "o2.z12");

                                fireComeToState(context, path, "s8");

                                // s8 []
                                return new StateMachineConfig("s8");


                            case e221:

                                // Connected->s8 e221[true]/o2.z7,o2.z9

                                fireTransitionCandidate(context, path, "Connected", event, "Connected#s8#e221#true");


                                fireTransitionFound(context, path, "Connected", event, "Connected#s8#e221#true");

                                fireBeforeOutputActionExecution(context, path, "Connected#s8#e221#true", "o2.z7");

                                o2.z7(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s8#e221#true", "o2.z7");
                                fireBeforeOutputActionExecution(context, path, "Connected#s8#e221#true", "o2.z9");

                                o2.z9(context);

                                fireAfterOutputActionExecution(context, path, "Connected#s8#e221#true", "o2.z9");

                                fireComeToState(context, path, "s8");

                                // s8 []
                                return new StateMachineConfig("s8");


                            default:

                                // transition not found
                                return config;
                        }

                    case Sending_File:


                        switch (e) {
                            case e235:

                                // Sending File->Idle e235[o2.x1]/o2.z10,o2.z5,o2.z8

                                fireTransitionCandidate(context, path, "Sending File", event, "Sending File#Idle#e235#o2.x1");

                                if (!isInputActionCalculated(calculatedInputActions, _o2_x1)) {

                                    fireBeforeInputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.x1");

                                    o2_x1 = o2.x1(context);

                                    fireAfterInputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.x1", new Boolean(o2_x1));
                                }


                                if (o2_x1) {

                                    fireTransitionFound(context, path, "Sending File", event, "Sending File#Idle#e235#o2.x1");

                                    fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z5");

                                    o2.z5(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z5");
                                    fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Idle#e235#o2.x1", "o2.z8");

                                    fireComeToState(context, path, "Idle");

                                    // Idle []
                                    return new StateMachineConfig("Idle");

                                }
                                // Sending File->Sending File e235[!o2.x1]/o2.z10,o2.z4,o2.z8

                                fireTransitionCandidate(context, path, "Sending File", event, "Sending File#Sending File#e235#!o2.x1");


                                if (!o2_x1) {

                                    fireTransitionFound(context, path, "Sending File", event, "Sending File#Sending File#e235#!o2.x1");

                                    fireBeforeOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z4");

                                    o2.z4(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z4");
                                    fireBeforeOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Sending File#Sending File#e235#!o2.x1", "o2.z8");

                                    fireComeToState(context, path, "Sending File");

                                    // Sending File []
                                    return new StateMachineConfig("Sending File");

                                }

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                            case e211:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e221:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e236:

                                // Sending File->Idle e236[true]/o2.z10,o2.z6,o2.z8

                                fireTransitionCandidate(context, path, "Sending File", event, "Sending File#Idle#e236#true");


                                fireTransitionFound(context, path, "Sending File", event, "Sending File#Idle#e236#true");

                                fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z10");

                                o2.z10(context);

                                fireAfterOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z10");
                                fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z6");

                                o2.z6(context);

                                fireAfterOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z6");
                                fireBeforeOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z8");

                                o2.z8(context);

                                fireAfterOutputActionExecution(context, path, "Sending File#Idle#e236#true", "o2.z8");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Sending_List:


                        switch (e) {
                            case e211:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e233:

                                // Sending List->Sending List e233[!o2.x2]/o2.z10,o2.z2,o2.z8

                                fireTransitionCandidate(context, path, "Sending List", event, "Sending List#Sending List#e233#!o2.x2");

                                if (!isInputActionCalculated(calculatedInputActions, _o2_x2)) {

                                    fireBeforeInputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.x2");

                                    o2_x2 = o2.x2(context);

                                    fireAfterInputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.x2", new Boolean(o2_x2));
                                }


                                if (!o2_x2) {

                                    fireTransitionFound(context, path, "Sending List", event, "Sending List#Sending List#e233#!o2.x2");

                                    fireBeforeOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z2");

                                    o2.z2(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z2");
                                    fireBeforeOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Sending List#e233#!o2.x2", "o2.z8");

                                    fireComeToState(context, path, "Sending List");

                                    // Sending List []
                                    return new StateMachineConfig("Sending List");

                                }
                                // Sending List->Idle e233[o2.x2]/o2.z10,o2.z3,o2.z8

                                fireTransitionCandidate(context, path, "Sending List", event, "Sending List#Idle#e233#o2.x2");


                                if (o2_x2) {

                                    fireTransitionFound(context, path, "Sending List", event, "Sending List#Idle#e233#o2.x2");

                                    fireBeforeOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z3");

                                    o2.z3(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z3");
                                    fireBeforeOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Sending List#Idle#e233#o2.x2", "o2.z8");

                                    fireComeToState(context, path, "Idle");

                                    // Idle []
                                    return new StateMachineConfig("Idle");

                                }

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                            case e221:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Idle:


                        switch (e) {
                            case e232:

                                // Idle->Sending List e232[!o2.x2]/o2.z10,o2.z2,o2.z8

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Sending List#e232#!o2.x2");

                                if (!isInputActionCalculated(calculatedInputActions, _o2_x2)) {

                                    fireBeforeInputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.x2");

                                    o2_x2 = o2.x2(context);

                                    fireAfterInputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.x2", new Boolean(o2_x2));
                                }


                                if (!o2_x2) {

                                    fireTransitionFound(context, path, "Idle", event, "Idle#Sending List#e232#!o2.x2");

                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z2");

                                    o2.z2(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z2");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending List#e232#!o2.x2", "o2.z8");

                                    fireComeToState(context, path, "Sending List");

                                    // Sending List []
                                    return new StateMachineConfig("Sending List");

                                }
                                // Idle->Idle e232[o2.x2]/o2.z10,o2.z3,o2.z8

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Idle#e232#o2.x2");


                                if (o2_x2) {

                                    fireTransitionFound(context, path, "Idle", event, "Idle#Idle#e232#o2.x2");

                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z3");

                                    o2.z3(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z3");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e232#o2.x2", "o2.z8");

                                    fireComeToState(context, path, "Idle");

                                    // Idle []
                                    return new StateMachineConfig("Idle");

                                }

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                            case e234:

                                // Idle->Idle e234[o2.x1]/o2.z10,o2.z5,o2.z8

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Idle#e234#o2.x1");

                                if (!isInputActionCalculated(calculatedInputActions, _o2_x1)) {

                                    fireBeforeInputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.x1");

                                    o2_x1 = o2.x1(context);

                                    fireAfterInputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.x1", new Boolean(o2_x1));
                                }


                                if (o2_x1) {

                                    fireTransitionFound(context, path, "Idle", event, "Idle#Idle#e234#o2.x1");

                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z5");

                                    o2.z5(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z5");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Idle#e234#o2.x1", "o2.z8");

                                    fireComeToState(context, path, "Idle");

                                    // Idle []
                                    return new StateMachineConfig("Idle");

                                }
                                // Idle->Sending File e234[!o2.x1]/o2.z10,o2.z4,o2.z8

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#Sending File#e234#!o2.x1");


                                if (!o2_x1) {

                                    fireTransitionFound(context, path, "Idle", event, "Idle#Sending File#e234#!o2.x1");

                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z10");

                                    o2.z10(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z10");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z4");

                                    o2.z4(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z4");
                                    fireBeforeOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z8");

                                    o2.z8(context);

                                    fireAfterOutputActionExecution(context, path, "Idle#Sending File#e234#!o2.x1", "o2.z8");

                                    fireComeToState(context, path, "Sending File");

                                    // Sending File []
                                    return new StateMachineConfig("Sending File");

                                }

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                            case e237:

                                // Idle->s8 e237[true]/o2.z10,o2.z11

                                fireTransitionCandidate(context, path, "Idle", event, "Idle#s8#e237#true");


                                fireTransitionFound(context, path, "Idle", event, "Idle#s8#e237#true");

                                fireBeforeOutputActionExecution(context, path, "Idle#s8#e237#true", "o2.z10");

                                o2.z10(context);

                                fireAfterOutputActionExecution(context, path, "Idle#s8#e237#true", "o2.z10");
                                fireBeforeOutputActionExecution(context, path, "Idle#s8#e237#true", "o2.z11");

                                o2.z11(context);

                                fireAfterOutputActionExecution(context, path, "Idle#s8#e237#true", "o2.z11");

                                fireComeToState(context, path, "s8");

                                // s8 []
                                return new StateMachineConfig("s8");


                            case e211:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            case e221:

                                // go to super state only if it process given event or any event
                                s = Connected;
                                break;
                            default:

                                // go to super state only if it process given event or any event
                                // transition not found
                                return config;
                        }

                        break;
                    case Handshaking:


                        switch (e) {
                            case e231:

                                // Handshaking->Idle e231[true]/o2.z1,o2.z8

                                fireTransitionCandidate(context, path, "Handshaking", event, "Handshaking#Idle#e231#true");


                                fireTransitionFound(context, path, "Handshaking", event, "Handshaking#Idle#e231#true");

                                fireBeforeOutputActionExecution(context, path, "Handshaking#Idle#e231#true", "o2.z1");

                                o2.z1(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Idle#e231#true", "o2.z1");
                                fireBeforeOutputActionExecution(context, path, "Handshaking#Idle#e231#true", "o2.z8");

                                o2.z8(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#Idle#e231#true", "o2.z8");

                                fireComeToState(context, path, "Idle");

                                // Idle []
                                return new StateMachineConfig("Idle");


                            case e211:

                                // Handshaking->s8 e211[true]/o2.z12

                                fireTransitionCandidate(context, path, "Handshaking", event, "Handshaking#s8#e211#true");


                                fireTransitionFound(context, path, "Handshaking", event, "Handshaking#s8#e211#true");

                                fireBeforeOutputActionExecution(context, path, "Handshaking#s8#e211#true", "o2.z12");

                                o2.z12(context);

                                fireAfterOutputActionExecution(context, path, "Handshaking#s8#e211#true", "o2.z12");

                                fireComeToState(context, path, "s8");

                                // s8 []
                                return new StateMachineConfig("s8");


                            default:

                                // transition not found
                                return config;
                        }

                    default:
                        throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A2]");
                }
            }
        }

        //o2.x1
        private static final int _o2_x1 = 0;
        //o2.x2
        private static final int _o2_x2 = 1;

    }

    private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
        boolean b = calculatedInputActions.get(k);

        if (!b) {
            calculatedInputActions.set(k);
        }

        return b;
    }

}
	
