package ru.ifmo.fileShare.common;

import java.util.TimerTask;


import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContext;

public abstract class BaseTimer implements EventProvider {
    private java.util.Timer t;
    protected ModelEngine engine;

	public void init(ModelEngine engine) throws CommonException {
    	this.engine = engine;
    	
    	init();
	}

	public void dispose() {
		clearTimer();
	}
	
	protected abstract void init();
	
	protected abstract String getEvent();

    protected abstract long getTimeout();

    public void startTimer(final StateMachineContext context) {
        if (getTimeout() != 0) {
            t = new java.util.Timer(false);
            t.schedule(
                    new TimerTask() {
                        public void run() {
                            BaseTimer.this.engine.getEventManager().handle(
                                    new Event(getEvent()), context);
                        }
                    }, getTimeout());
        }
    }
	
	public void clearTimer() {
		if (t != null) {
			t.cancel();
		}
	}
}
