package ru.ifmo.fileShare.gui;

import ru.ifmo.fileShare.util.ClientInfo;

import javax.swing.table.AbstractTableModel;
import java.text.DateFormat;

public class ClientInfoTableModel extends AbstractTableModel {
    protected String[] fields = {"Host Name: ", "IP address:", "Connected Since: ", "Client State: "};
    protected ClientInfo clientInfo;
    private static final String CLIENT_NOT_CONNECTED = "<Client not connected>";

    public ClientInfoTableModel() {
        clientInfo = null;
    }

    public int getRowCount() {
        return 4;
    }

    public int getColumnCount() {
        return 2;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        if (columnIndex == 0) {
            return fields[rowIndex];
        } else {
            switch (rowIndex) {
                case 0:
                    return clientInfo == null ? CLIENT_NOT_CONNECTED : clientInfo.getHostName();
                case 1:
                    return clientInfo == null ? CLIENT_NOT_CONNECTED : clientInfo.getIp();
                case 2:
                    if (clientInfo != null) {
                        return DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(clientInfo.getConnectedDate());
                    } else {
                        return CLIENT_NOT_CONNECTED;
                    }
                case 3:
                    return clientInfo == null ? CLIENT_NOT_CONNECTED : clientInfo.getActions();
            }
        }
        return "";
    }

    public void setClientInfo(ClientInfo clientInfo) {
        this.clientInfo = clientInfo;
        fireTableDataChanged();
    }
}
