package ru.ifmo.fileShare.gui;

import ru.ifmo.fileShare.Consts;
import ru.ifmo.fileShare.util.WindowUtils;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;

public class ConnectDialog extends JDialog {
    protected ResourceBundle props = ResourceBundle.getBundle("ru.ifmo.fileShare.gui.form");

    public ConnectDialog(final ConnectDlgListener onConnectListener) {
        super(SharingApp.getInstance(), true);
        setTitle(props.getString("connection_props"));
        setResizable(false);
        Container c = getContentPane();
        c.setLayout(new BorderLayout(5, 5));
        JPanel container = new JPanel();
        c.add(container, BorderLayout.CENTER);
        container.setBorder(new EmptyBorder(5, 5, 5, 5));
        container.setLayout(new GridLayout(2, 2, 5, 5));
        container.add(new JLabel(props.getString("host_name")));
        final JTextField hostName = new JTextField();
        container.add(hostName);
        container.add(new JLabel(props.getString("port")));
        final JTextField port = new JTextField();
        port.setText(String.valueOf(Consts.SERVER_PORT));
        container.add(port);

        JPanel buttonPane = new JPanel();
        JButton connectButton = new JButton(props.getString("connect"));
        getRootPane().setDefaultButton(connectButton);
        buttonPane.add(connectButton);
        JButton cancelButton = new JButton(props.getString("cancel"));
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });
        connectButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    onConnectListener.onConnect(hostName.getText(), port.getText());
                    dispose();
                }
            }
        );
        buttonPane.add(cancelButton);
        c.add(buttonPane, BorderLayout.SOUTH);

        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        setSize(new Dimension(300, 140));
        WindowUtils.locateAtScreenCenter(this);
    }

    public void start() {
        setVisible(true);
    }

    public static interface ConnectDlgListener {
        public void onConnect(String hostName, String port);
    }
}
