package ru.ifmo.fileShare.gui;

import ru.ifmo.fileShare.gui.controls.FolderInfoTreeNode;
import ru.ifmo.fileShare.util.FolderInfo;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreePath;
import java.util.List;

public class FolderTreeModel extends DefaultTreeModel {
    public FolderTreeModel() {
        super(new FolderInfoTreeNode());
    }

    public void updateData(List<FolderInfo> sharedFolderInfo) {
        FolderInfoTreeNode root = createNode();
        addChildrenRecursive(root, sharedFolderInfo);
        setRoot(root);
    }

    private FolderInfoTreeNode createNode() {
        return new FolderInfoTreeNode();
    }

    private void addChildrenRecursive(FolderInfoTreeNode root, List<FolderInfo> children) {
        if (children == null) {
            return;
        }
        for (FolderInfo fi : children) {
            if (fi.isDirectory()) {
                FolderInfoTreeNode child = createNode();
                child.setUserObject(fi);
                root.add(child);
                addChildrenRecursive(child, fi.getChildren());
            }
        }
    }

    public void valueForPathChanged(TreePath path, Object newValue) {
        MutableTreeNode aNode = (MutableTreeNode) path.getLastPathComponent();
        nodeChanged(aNode);
    }
}
