package ru.ifmo.fileShare.gui.controls;

import ru.ifmo.fileShare.util.FolderInfo;

import javax.swing.*;
import javax.swing.tree.DefaultTreeCellRenderer;
import java.awt.*;

public class FolderTreeCellRenderer extends DefaultTreeCellRenderer {

    private JPanel pane;
    public JCheckBox cbx;

    public FolderTreeCellRenderer() {
        pane = new JPanel();
        cbx = new JCheckBox();
        pane.setOpaque(false);
        cbx.setOpaque(false);
    }

    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        Component parent = super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
        FolderInfoTreeNode node = (FolderInfoTreeNode) value;
        if (node.getUserObject() == null) {
            return parent;
        }
        FolderInfo fi = (FolderInfo) node.getUserObject();
        cbx.setSelected(fi.isParentSelected());
        cbx.setEnabled(!fi.isDisabled());

        pane.removeAll();
        pane.setLayout(new BorderLayout());
        pane.add(cbx, BorderLayout.WEST);
        pane.add(parent, BorderLayout.CENTER);
        return pane;
    }
}
