package ru.ifmo.fileShare.gui.controls;

import javax.swing.*;
import java.util.ArrayList;

public class TreeNodeExpandState {
    private int rows = 0;
    private ArrayList<Boolean> expansionData;

    public TreeNodeExpandState() {
        this(0);
    }

    public TreeNodeExpandState(int rows) {
        setRows(rows);
        if (rows > 0)
            expansionData = new ArrayList<Boolean>(rows);
        else
            expansionData = new ArrayList<Boolean>();
    }

    public int getRows() {
        return rows;
    }

    public void setRows(int rows) {
        this.rows = rows;
    }

    public void setRowExpanded(int row, boolean expanded) {
        if (row >= expansionData.size()) {
            for (int i = 0; i < row - expansionData.size() + 1; i++)
                expansionData.add(false);
        }
        expansionData.set(row, expanded);
    }

    public boolean getRowExpanded(int row) {
        return expansionData.get(row);
    }

    public static TreeNodeExpandState getNodesExpandedState(JTree tree) {
        int rows = tree.getRowCount();
        TreeNodeExpandState state = new TreeNodeExpandState(rows);
        for (int i = 0; i < rows; i++) {
            state.setRowExpanded(i, tree.isExpanded(i));
        }
        return state;
    }

    public static void setNodesExpandedState(JTree tree, TreeNodeExpandState state) {
        if (state != null) {
            for (int i = 0; i < state.getRows(); i++) {
                if (i < tree.getRowCount())
//                    break;
                    if (state.getRowExpanded(i)) {
                        tree.expandRow(i);
                    }
            }
        }
    }
}