package ru.ifmo.fileShare.transport;

import java.io.Serializable;

public class Command implements Serializable {

	/**
	 * Serialization UID
	 */
	private static final long serialVersionUID = 7633612571683213173L;
	
	public static final int CLIENT_HELLO = 1;
	public static final int CLIENT_BYE = 2;
	public static final int CLIENT_FIRST_LIST_PART = 3;
    public static final int CLIENT_NEXT_LIST_PART = 4;
    public static final int CLIENT_CANCEL_FILE_DOWNLOAD = 5;
    public static final int CLIENT_FIRST_FILE_PART = 6;
	public static final int CLIENT_NEXT_FILE_PART = 7;

	public static final int SERVER_HERE = 10;
	public static final int SERVER_LIST_PART = 11;
    public static final int SERVER_LAST_LIST_PART = 12;
	public static final int SERVER_FILE_PART = 13;
	public static final int SERVER_LAST_FILE_PART = 14;
	public static final int SERVER_BYE = 15;
	
	private int commandType;
	private Serializable data;
	
	public Command(int commandType) {
		this(commandType, null);
	}
	
	public Command(int commandType, Serializable data) {
		this.commandType = commandType;
		this.data = data;
	}
	
	public Serializable getData() {
		return data;
	}
	
	public int getType() {
		return commandType;
	}
}
