package ru.ifmo.fileShare.transport;

import java.io.Serializable;
import java.util.Date;

public class FileListItem implements Serializable {
    private static final long serialVersionUID = 7633612571683213174L;

    private boolean isDirectory;
    private String path;
    private String name;
    private long size;
    private Date modified;
    private long fileID;
    private boolean hasChildren;

    public FileListItem(long fileID, String path, String name, boolean hasChildren) {
        this(fileID, path, name, true, 0, null, hasChildren);
    }

    public FileListItem(long fileID, String path, String name, long size, Date modified) {
        this(fileID, path, name, false, size, modified, false);
    }

    private FileListItem(long fileID, String path, String name, boolean isDirectory, long size, Date modified, boolean hasChildren) {
        this.isDirectory = isDirectory;
        this.path = path;
        this.name = name;
        this.size = size;
        this.modified = modified;
        this.fileID = fileID;
        this.hasChildren = hasChildren;
    }

    public boolean isDirectory() {
        return isDirectory;
    }

    public String getPath() {
        return path;
    }

    public String getName() {
        return name;
    }

    public long getSize() {
        return size;
    }

    public Date getModified() {
        return modified;
    }

    public long getFileID() {
        return fileID;
    }

    public boolean hasChildren() {
        return hasChildren;
    }
}
