package ru.ifmo.fileShare.util;

import javax.swing.*;

public abstract class FolderEnumeratorProgress implements Progress {
    private FolderInfo folderInfo;
    public static final int FINISHED = 1;
    public static final int FAILED = 2;
    public static final int CANCELED = 3;
    private boolean canceled;

    public FolderEnumeratorProgress() {
        folderInfo = null;
        canceled = false;
    }

    public void setFolderInfo(FolderInfo folderInfo) {
        this.folderInfo = folderInfo;
    }

    public void changeState(final int state) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                onFinished(state, folderInfo);
            }
        });
    }

    public abstract void onFinished(int state, FolderInfo folderInfo);

    public boolean isCanceled() {
        return canceled;
    }

    public void cancel() {
        this.canceled = true;
    }
}
